Subject: Re: [PATCH 2/3] netpoll: rework skb transmit queue

From: Stephen Hemminger <[email-masked]>
Date: Fri, 20 Oct 2006 13:14:09 -0700

On Fri, 20 Oct 2006 12:52:26 -0700 (PDT)
David Miller <[email-masked]> wrote:

> From: Stephen Hemminger <[email-masked]>
> Date: Fri, 20 Oct 2006 12:25:27 -0700
> 
> > Sorry, but why should we treat out-of-tree vendor code any
> > differently than out-of-tree other code.
> 
> I think what netdump was trying to do, provide a way to
> requeue instead of fully drop the SKB, is quite reasonable.
> Don't you think?

Yes, but the queued vs non-queued stuff showed up out of order.
The queued messages go through the wrong Tx path. ie. they end up
going into to NIT etc, since the deferred send uses a work queue
it wouldn't work for last-gasp messages or netdump since getting
a work queue to run requires going back to scheduler and processes
running... and it should use skb_buff_head instead
of roll your own queueing.

The other alternative would be to make the send logic non-blocking
and fully push retry to the caller.

I'll make a fix to netdump, if I can find it.

-- 
Stephen Hemminger <[email-masked]>